import sexpr
import cStringIO

def do_test(name, string, expr_string_tuple, comments = True):
    failed = False
    input = cStringIO.StringIO(string)
    i = 0
    for expr in sexpr.Parser(sexpr.Lexer(name, input), comments):
        if repr(expr) != expr_string_tuple[i]:
            failed = True
            print name, "Failed to match expression %d:" % (i)
            print repr(expr)
            print expr_string_tuple[i]
        i += 1
    while i != len(expr_string_tuple):
        failed = True
        print name, "Failed to return expression %d: %s" % (i, expr_string_tuple[i])
        i += 1
    if not failed:
        print name, "Passed"

tests = [
('42', ['sexpr.Int(1, 1, 42)']),
('hello world', ["sexpr.Token(1, 1, 'hello')", "sexpr.Token(1, 6, 'world')"]),
('"Goodbye!"#comment', ["sexpr.String(1, 1, 'Goodbye!')", "sexpr.Comment(1, 11, '#comment')"]),
]
n = len(tests)
i = 1
for test in tests:
    do_test('test %d of %d' % (i, n), test[0], test[1])
    i += 1
